
import Smonad
import Mpi

-- mobile phone directory

clear   = write []

store n = T((split length id) . npush10 n)

del n   = T((split length id) . tail . npush10 n)

call n  = T((split head id) . npush10 n)

npush10 :: Eq a => a -> [a] -> [a]
npush10 n = (take 10) . (npush n)
            where npush n s = [n] ++ (filter (/=n) s)

storebatch l = sequence_ (do i <- l ; return (store i))
-- cf [ store i | i <- l ] 

{-- test suite

exec (do { clear ; store 253000111 ; store 253000222 ; call253000111 ; call 253000333 ; del 253000111 } ) []

exec (sequence_ [ store i | i <- [1,2,3]] ) [4]

--}
